<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Preprocessing</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="preprocessing">Preprocessing </a></h1><hr/>
<p><b>Sections:</b></p>
<ul>
<li><a class="el" href="preprocessing.html#gmsh">Gmsh</a><ul>
<li><a class="el" href="preprocessing.html#bettermesh">Optimizing meshes</a></li>
<li><a class="el" href="preprocessing.html#gmshcli">Command-line meshing</a></li>
</ul>
</li>
<li><a class="el" href="preprocessing.html#netgen">NETGEN</a></li>
<li><a class="el" href="preprocessing.html#salome">Salome</a></li>
<li><a class="el" href="preprocessing.html#pre_gid">GiD</a></li>
<li><a class="el" href="preprocessing.html#patran">MSC.Patran</a></li>
</ul>
<hr/>
<p>Several files are required for the configuration and initialization of a simulation (cf. <a class="el" href="input.html">Input Files for Simulations</a>). However, they are very easy to adapt from existing <a class="el" href="examples.html">Examples</a> and finite element meshes of several simple geometries are included in the package of <a class="el" href="examples.html">Examples</a> available on the <a href="http://www.magpar.net/DownloadPage">download page</a>.</p>
<p>If a new geometry is required, some more advanced tools are necessary. magpar can import <a href="http://help.avs.com/Express/doc/help/reference/dvmac/UCD_Form.htm">UCD files</a> and <a class="el" href="preprocessing.html#patran">MSC.Patran</a> neutral files. The <a href="http://help.avs.com/Express/doc/help/reference/dvmac/UCD_Form.htm">UCD format</a> is very simple, so it should be very easy to write export filters/converters for other mesh generators, too.</p>
<p>The following CAD software and mesh generators have been used to generate geometries and finite element meshes for magpar.</p>
<hr/>
<h2><a class="anchor" id="gmsh">
Gmsh</a></h2>
<p>From the <a href="http://geuz.org/gmsh/">Gmsh homepage</a>:</p>
<div class="fragment"><pre class="fragment">
Gmsh: a three-dimensional finite element mesh generator with built-in pre-
and post-processing facilities

Gmsh is an automatic 3D finite element grid generator with a built-in
CAD engine and post-processor. Its design goal is to provide a
simple meshing tool for academic problems with parametric input and
advanced visualization capabilities.

Gmsh is built around four modules: geometry, mesh, solver and post-processing.
The specification of any input to these modules is done either interactively
using the graphical user interface or in ASCII text files using Gmsh's own
scripting language.
</pre></div><p>After defining the geometry the 3D tetrahedral mesh has to be generated. Gmsh uses <a href="http://tetgen.berlios.de/">TetGen</a> or <a href="http://www.hpfem.jku.at/netgen/">NETGEN</a> to generate the tetrahedral finite element mesh.</p>
<p>The mesh is then exported using Mesh/Save or File/Save Mesh as a *.msh file. In order to assign different property ids to different parts of the volume it is necessary to define corresponding "Physical groups" (Add/Volume). In addition, it might be necessary to tweak the ids of these physical volumes by hand in the *.geo file to ensure that these physical volumes are numbered consecutively starting from 1.</p>
<p>Sometimes, Gmsh completes the mesh generation but it cannot save the mesh. If this happens, it can help to increase the Linux/Unix resources - in particular the maximum number of open files - in /etc/security/limits.conf: </p>
<div class="fragment"><pre class="fragment">
*                hard    nofile          10000
</pre></div><p> see: <a href="http://www.geuz.org/pipermail/gmsh/2008/003318.html">http://www.geuz.org/pipermail/gmsh/2008/003318.html</a></p>
<p>This issue has been resolved in Gmsh version 2.2.1: <a href="http://www.geuz.org/pipermail/gmsh/2008/003323.html">http://www.geuz.org/pipermail/gmsh/2008/003323.html</a></p>
<p>The Python program <a class="el" href="tools.html#gmshtoucd">gmsh: gmshtoucd.py</a> (provided in the $MAGPAR_HOME/src/tools/ directory), can then be used to convert Gmsh <a href="http://geuz.org/gmsh/doc/texinfo/gmsh_10.html#SEC65">mesh files (version 2.0)</a> into UCD/inp files (cf. <a class="el" href="input.html#project_inp">project.inp, project.out: finite element mesh</a>).</p>
<p>The examples <a class="el" href="examples.html#sphere_larmor">sphere_larmor: Larmor precession</a> and <a class="el" href="examples.html#mumag3b">mumag3b: mumag standard problem #3 with 2 cubes</a> use finite element meshes generated with Gmsh.</p>
<h3><a class="anchor" id="bettermesh">
Optimizing meshes</a></h3>
<p><b>Sometimes Gmsh will generate a suboptimal mesh!</b> This will often cause magpar to run very slowly (because the mesh structure results in larger numerical errors in the magnetostatic field, which causes the time integrator to take very small time steps) or to fail when the linear solvers (for the calculation of the magnetostatic field, e.g. Au1*u1=divM in <a class="el" href="field_8h.html#a8e779a08a066fda9160df1a7e5102a58">Hdemag()</a>) do not converge. You can check for a bad mesh by looking at the .felog generated by magpar at startup: </p>
<div class="fragment"><pre class="fragment">
simname: strip
[...]
elevol:
  id_min: 7241
  id_max: 5335
  Vmax:   22.4616
  Vmin:   0.0000158533
  ratio:  1416840
  Vavg:   6.43932
  Vtot:   62500
[...]
edge_len_min: 0.003124
edge_len_max: 7.59121
edge_len_avg: 4.32508
[...]
</pre></div><p> Notice in this example that the ratio of the volume of the largest cell in the mesh to that of the smallest cell is <b>1416840</b>. Furthermore, the shortest edge (<code>edge_len_min</code>) is 2500 times shorter than the longest edge (<code>edge_len_max</code>). This will probably cause problems for magpar.</p>
<p>If Gmsh produces a poor mesh, there are a few things to try (options to insert at the beginning of the .geo file):</p>
<ul>
<li>try changing the meshing algorithm used by setting the variable <code>Mesh.Algorithm3D</code> in your .geo file: <div class="fragment"><pre class="fragment">
Mesh.Algorithm3D=1; // for Tetgen+Delaunay (default)
Mesh.Algorithm3D=4; // for Netgen
</pre></div></li>
<li>if this doesn't work, try optimizing the mesh by setting the variable <code>Mesh.Optimize</code> or <code>Mesh.OptimizeNetgen</code>: <div class="fragment"><pre class="fragment">
Mesh.Optimize=1;
Mesh.OptimizeNetgen=1;
</pre></div></li>
</ul>
<h3><a class="anchor" id="gmshcli">
Command-line meshing</a></h3>
<p>Gmsh can be invoked from the command line to generate a 3D mesh from a .geo file, which allows the process to be scripted. This is done by invoking gmsh with the <code>-3</code> option, as in:</p>
<div class="fragment"><pre class="fragment">
$ gmsh -3 filename.geo
</pre></div><p>The <code>-optimize</code> and <code>-optimize_netgen</code> options may be added to produce an optimized mesh (equivalent to setting the <code>Mesh.Optimize</code> or <code>Mesh.OptimizeNetgen</code> variable in the .geo file).</p>
<hr/>
<h2><a class="anchor" id="netgen">
NETGEN</a></h2>
<p>From the <a href="http://www.mathcces.rwth-aachen.de/netgen/">NETGEN homepage</a> (<a href="http://www.hpfem.jku.at/netgen/">Linz site</a>):</p>
<div class="fragment"><pre class="fragment">
NETGEN is an automatic 3d tetrahedral mesh generator. It accepts input from
constructive solid geometry (CSG) or boundary representation (BRep) from
STL file format. The connection to a geometry kernel allows the handling of
IGES and STEP files. NETGEN contains modules for mesh optimization and
hierarchical mesh refinement. Netgen is open source based on the LGPL license.
It is available for Unix/Linux and Windows.
</pre></div><p><a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a> and <a href="http://www.soton.ac.uk/~fangohr/">Hans Fangohr</a> have implemented the tool <a class="el" href="tools.html#ngtoucd">ngtoucd.py</a>, which converts neutrally-exported NETGEN meshes into AVS/UCD files (cf. <a class="el" href="input.html#project_inp">project.inp, project.out: finite element mesh</a>).</p>
<p>NETGEN can be found here:</p>
<ul>
<li><a href="http://www.mathcces.rwth-aachen.de/netgen/">http://www.mathcces.rwth-aachen.de/netgen/</a></li>
<li><a href="http://www.hpfem.jku.at/netgen/">http://www.hpfem.jku.at/netgen/</a></li>
<li><a href="http://netgen-mesher.wiki.sourceforge.net/">http://netgen-mesher.wiki.sourceforge.net/</a></li>
<li><a href="http://sourceforge.net/projects/netgen-mesher">http://sourceforge.net/projects/netgen-mesher</a></li>
</ul>
<hr/>
<h2><a class="anchor" id="salome">
Salome</a></h2>
<p><a href="http://www.salome-platform.org/">Salome</a> provides a generic platform for Pre- and Post-Processing for numerical simulations. It is based on an open and flexible architecture made of reusable components.</p>
<p>Salome has powerful tools to generate 3D geometries (even with combinations of bottom-up [points &gt; lines &gt; faces &gt; volumes] and top-down approaches [3D shapes &gt; volumes &gt; faces &gt; lines &gt; points] and tools to generate unions, intersections, cuts, etc.), mesh them, and export them in various formats.</p>
<p>Currently, there are no converters for the FE meshes generated by Salome yet, but <a class="el" href="preprocessing.html#gmsh">Gmsh</a> can import Salome's output.</p>
<hr/>
<h2><a class="anchor" id="pre_gid">
GiD</a></h2>
<p><a href="http://www.gid-usa.com/">GiD</a> is the "personal pre- and postprocessor" from the "International Center for Numerical Methods in Engineering" (CIMNE). An evaluation version, which is restricted to 3000 finite elements, is available on the web for free. The installation of GiD is very easy on Windows as well as Linux platforms.</p>
<p>After the installation of GiD the new problem type "inp.gid" should be installed. This is done by copying the directory "$MAGPAR_HOME/src/tools/gid/inp.gid" to the subdirectory "problemtypes" of your GiD installation. If GiD recognized the new problem type, there should be an entry "inp" in the "Data/Problem type" menu.</p>
<p>In order to create a the finite element mesh of a simple geometry and export it in inp format, the following steps are required:</p>
<ol type="1">
<li>start GiD</li>
<li>set problem type: <br/>
 "Data/Problem type/inp"</li>
<li>create a sphere: <br/>
 "Geometry/Create/Object/Sphere"</li>
<li>enter the center of the sphere, e.g. <br/>
 "0,0,0"</li>
<li>enter the desired radius, e.g. <br/>
 "1"</li>
<li>create more geometric objects, e.g. a second sphere:</li>
<li>create a sphere: <br/>
 "Geometry/Create/Object/Sphere"</li>
<li>enter the center of the sphere, e.g. <br/>
 "3,0,0"</li>
<li>enter the desired radius, e.g. <br/>
 "1"</li>
<li>assign "Conditions" (=property ids=grain numbers) - the corresponding material parameters are later defined in <a class="el" href="input.html#project_krn">project.krn: material properties</a> in the appropriate line (line number=property id): <br/>
 "Data/Conditions"</li>
<li>set grain number <br/>
 "grain number 1"</li>
<li>"Assign"</li>
<li>select all objects, which should have property id "1", e.g. the left sphere</li>
<li>press the "Finish" button or the Esc key when finished</li>
<li>set grain number <br/>
 "grain number 2"</li>
<li>"Assign"</li>
<li>select all objects, which should have property id "2", e.g. the right sphere</li>
<li>press the "Finish" button or the Esc key when finished, "Close" the dialog window</li>
<li>If you have created independent points, lines, or surfaces delete them all <br/>
 (this is not necessary for the two spheres in this simple example): <br/>
 "Geometry/Delete/Point" <br/>
 "Geometry/Delete/Line" <br/>
 "Geometry/Delete/Surface" <br/>
 only volumes should be left over!</li>
<li>generate a tetrahedral finite element mesh: <br/>
 "Meshing/Generate"</li>
<li>Enter the size of elements, e.g. <br/>
 "0.3"</li>
<li>save the project: <br/>
 "Files/Save" "sphere"</li>
<li>generate the inp file: <br/>
 Calculate/Calculate</li>
<li>the inp file will be stored in the project directory "sphere.gid" with the suffix "dat", e.g. "sphere.dat"</li>
<li>rename the inp file: <br/>
 mv sphere.dat sphere.inp</li>
</ol>
<p>Now you can check the validity of the inp file by rendering it with ParaView (cf. section <a class="el" href="postprocessing.html">Postprocessing</a>).</p>
<hr/>
<h2><a class="anchor" id="patran">
MSC.Patran</a></h2>
<p><a href="http://www.mscsoftware.com/Contents/Products/CAE-Tools/Patran.aspx">MSC.Patran</a> is another CAD program, which includes a mesher to generate finite element meshes. It can export the finite element meshes as <a href="http://www.g-boege.de/english/makrosae/Manual/PATRAN.htm">"neutral files"</a>, which can also be imported by magpar. </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

